%
% 		 Course:	Biomedical Signal Processing
% Post-Graduate-Studies:        Biomedical Engineering-BΙM
%				University of Patras
%   		   Date:	04-04-2016
% 
%               Part 02:        Narrow and Wide-band Noise 
%				Filters in Time and Frequency Domain
%				Filters representaion in Time, Frequency, z-plane domains
%				Filtering artificial signals
%				Low-pas, band-pass, High-pass filters
%				Examples using ECG signals
%				Examples using EEG signals
%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%    Sinusoidal elimination in the time domain using IIR filters 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
clear all
close all

% Load ECG signal x. Sampling rate at 360 Hz 	
load ECGnoise50

% Compute DC and remove it.
x = x - mean(x) ;

%%% Estimation of IIR fiter Coefficients

b = poly( [ exp(2*pi*i*50/360) exp(-2*pi*i*50/360)] )
a = poly( [ 0.9*exp(2*pi*i*50/360) 0.9*exp(-2*pi*i*50/360)] )
freqz(b,a,2500,360)

y = filter(b,a,x) ;
figure
subplot(2,1,1), plot(x)
subplot(2,1,2), plot(y)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%    Sinusoidal elimination in the time domain using IIR filters 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
clear all
close all

% Load ECG signal x. Sampling rate at 360 Hz 	
load ECGVeryHigh50

% Compute DC and remove it.
x = x - mean(x) ;

%%% Estimation of IIR fiter Coefficients

b = poly( [ exp(2*pi*i*50/360) exp(-2*pi*i*50/360)] )
a = poly( [ 0.99*exp(2*pi*i*50/360) 0.99*exp(-2*pi*i*50/360)] )
freqz(b,a,2500,360)

y = filter(b,a,x) ;
figure
subplot(2,1,1), plot(x)
subplot(2,1,2), plot(y)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%    DC, very low frwruencies and Sinusoidal 50 Hz elimination in the time domain using IIR filters 

%%% Estimation of IIR fiter Coefficients

b = poly( [ exp(2*pi*i*50/360) exp(-2*pi*i*50/360) exp(0) ] )
a = poly( [ 0.99*exp(2*pi*i*50/360) 0.99*exp(-2*pi*i*50/360) 0.99 ] )
freqz(b,a,2500,360)

y = filter(b,a,x) ;
figure
subplot(2,1,1), plot(x)
subplot(2,1,2), plot(y)


